-- FL6570
-- Specialization for FL6570 mod
--
-- @author  kA

FL6570 = {};

function FL6570.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Frontloader, specializations);
end;

function FL6570:load(xmlFile)
	self.supportArms = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.supportArms#index"));
    self.supportColli = self.components[2].node
end;

function FL6570:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FL6570:update(dt)
	if self.attacherVehicle ~= nil then
		setRigidBodyType(self.components[2].node, "NoRigidBody");
        local index1 = 0;
        local index2 = 1;
        local jointIndexStr = '0>2';

        local jointNode = Utils.indexToObject(self.components, jointIndexStr);
        if jointNode ~= nil and jointNode ~= 0 then
        	local x, y, z = getWorldTranslation(jointNode)
        	setTranslation(self.components[2].node, x, y, z)
        	local x, y, z = getWorldRotation(jointNode)
        	setRotation(self.components[2].node, x, y, z)
		end;
	end;
	
	if self.SupportCompAttach then
		local index1 = 0;
		local index2 = 1;
		local jointIndexStr = '0>2';
		local jointNode = Utils.indexToObject(self.components, jointIndexStr);
		if jointNode ~= nil and jointNode ~= 0 then
			local x, y, z = getWorldTranslation(jointNode)
			setTranslation(self.components[2].node, x, y, z)
			local x, y, z = getWorldRotation(jointNode)
			setRotation(self.components[2].node, x, y, z)

			local constr = JointConstructor:new();
			constr:setActors(self.components[index1+1].node, self.components[index2+1].node);
			constr:setJointTransforms(jointNode, jointNode);

			local x, y, z = Utils.getVectorFromString('0 0 0');
			local rotLimits = {};
			rotLimits[1] = math.rad(Utils.getNoNil(x, 0));
			rotLimits[2] = math.rad(Utils.getNoNil(y, 0));
			rotLimits[3] = math.rad(Utils.getNoNil(z, 0));

			local x, y, z = Utils.getVectorFromString('0 0 0');
			local transLimits = {};
			transLimits[1] = Utils.getNoNil(x, 0);
			transLimits[2] = Utils.getNoNil(y, 0);
			transLimits[3] = Utils.getNoNil(z, 0);

			for i=1, 3 do
				local rotLimit = rotLimits[i];
				if rotLimit >= 0 then
					constr:setRotationLimit(i-1, -rotLimit, rotLimit);
				end;

				local transLimit = transLimits[i];
				if transLimit >= 0 then
					constr:setTranslationLimit(i-1, true, -transLimit, transLimit);
				else
					constr:setTranslationLimit(i-1, false, 0, 0);
				end;
			end;
			local jointDesc = {};
			jointDesc.componentIndices = {index1+1, index2+1};
			jointDesc.jointNode = jointNode;
			jointDesc.jointIndex = constr:finalize();
			table.insert(self.componentJoints, jointDesc);
			self.SupportCompAttach = false;
		end;
	end;
end;
	
function FL6570:onDetach()
    setRigidBodyType(self.supportColli, "Dynamic");
	setVisibility(self.supportArms, true);
	self.SupportCompAttach = true;
	setCenterOfMass(self.components[1].node, 0, 0, 2);
end;

function FL6570:onAttach(attacherVehicle)
    setRigidBodyType(self.supportColli, "NoRigidBody");
	setVisibility(self.supportArms, false);	
	self.SupportCompAttach = false;
	setCenterOfMass(self.components[1].node, 0, 0, 0);
end;

function FL6570:delete()
end;

function FL6570:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FL6570:keyEvent(unicode, sym, modifier, isDown)
end;

function FL6570:draw()
end;




